igeo.io

## Class IRhino3dmImporter

- java.lang.Object
- - igeo.io.IRhino3dm
  - - igeo.io.IRhino3dmImporter

-     public class IRhino3dmImporter
      extends IRhino3dm

  Rhinoceros 3dm importer class.
  Author:
    Satoru Sugihara

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class igeo.io.IRhino3dm

      `IRhino3dm.AngularDimension, IRhino3dm.AngularDimension2, IRhino3dm.AngularDimension2Extra, IRhino3dm.Annotation, IRhino3dm.Annotation2, IRhino3dm.Annotation2Text, IRhino3dm.AnnotationArrow, IRhino3dm.AnnotationTextDot, IRhino3dm.AnnotationType, IRhino3dm.Arc, IRhino3dm.ArcCurve, IRhino3dm.Bitmap, IRhino3dm.BoundingBox, IRhino3dm.Brep, IRhino3dm.BrepEdge, IRhino3dm.BrepEdgeArray, IRhino3dm.BrepFace, IRhino3dm.BrepFaceArray, IRhino3dm.BrepFaceSide, IRhino3dm.BrepLoop, IRhino3dm.BrepLoopArray, IRhino3dm.BrepRegion, IRhino3dm.BrepRegionTopologyUserData, IRhino3dm.BrepTrim, IRhino3dm.BrepTrimArray, IRhino3dm.BrepTrimPoint, IRhino3dm.BrepVertex, IRhino3dm.BrepVertexArray, IRhino3dm.Chunk, IRhino3dm.ChunkTable, IRhino3dm.Circle, IRhino3dm.ClassRegistry, IRhino3dm.ClippingPlaneSurface, IRhino3dm.Curve, IRhino3dm.CurveArray, IRhino3dm.CurveOnSurface, IRhino3dm.CurveProxy, IRhino3dm.DetailView, IRhino3dm.DimensionExtra, IRhino3dm.DimStyle, IRhino3dm.DimStyleExtra, IRhino3dm.DisplayMaterialRef, IRhino3dm.EmbeddedBitmap, IRhino3dm.Endian, IRhino3dm.Extrusion, IRhino3dm.Font, IRhino3dm.Geometry, IRhino3dm.Group, IRhino3dm.Hatch, IRhino3dm.HatchExtra, IRhino3dm.HatchPattern, IRhino3dm.HistoryRecord, IRhino3dm.InstanceDefinition, IRhino3dm.InstanceRef, IRhino3dm.Interval, IRhino3dm.Layer, IRhino3dm.LayerExtensions, IRhino3dm.Leader, IRhino3dm.Leader2, IRhino3dm.Light, IRhino3dm.Line, IRhino3dm.LinearDimension, IRhino3dm.LinearDimension2, IRhino3dm.LineCurve, IRhino3dm.Linetype, IRhino3dm.MappingChannel, IRhino3dm.MappingTag, IRhino3dm.Material, IRhino3dm.MaterialRef, IRhino3dm.Mesh, IRhino3dm.MeshCurvatureStats, IRhino3dm.MeshEdgeRef, IRhino3dm.MeshFace, IRhino3dm.MeshFaceRef, IRhino3dm.MeshNgonUserData, IRhino3dm.MeshParameters, IRhino3dm.MeshVertexRef, IRhino3dm.MorphControl, IRhino3dm.NurbsCage, IRhino3dm.NurbsCurve, IRhino3dm.NurbsSurface, IRhino3dm.ObjectAttributes, IRhino3dm.OffsetSurface, IRhino3dm.OrdinateDimension2, IRhino3dm.Plane, IRhino3dm.PlaneEquation, IRhino3dm.PlaneSurface, IRhino3dm.Point, IRhino3dm.Point2Array, IRhino3dm.PointArray, IRhino3dm.PointCloud, IRhino3dm.PointGrid, IRhino3dm.PolyCurve, IRhino3dm.PolyEdgeCurve, IRhino3dm.PolyEdgeSegment, IRhino3dm.Polyline, IRhino3dm.PolylineCurve, IRhino3dm.Properties, IRhino3dm.RadialDimension, IRhino3dm.RadialDimension2, IRhino3dm.Rect, IRhino3dm.RenderingAttributes, IRhino3dm.RevSurface, IRhino3dm.Rhino3dmFile, IRhino3dm.RhinoObject, IRhino3dm.Settings, IRhino3dm.StartSection, IRhino3dm.SumSurface, IRhino3dm.Surface, IRhino3dm.SurfaceArray, IRhino3dm.SurfaceCurvature, IRhino3dm.SurfaceProxy, IRhino3dm.TextDisplayMode, IRhino3dm.TextDot, IRhino3dm.TextEntity, IRhino3dm.TextEntity2, IRhino3dm.TextExtra, IRhino3dm.Texture, IRhino3dm.TextureCoordinates, IRhino3dm.TextureMapping, IRhino3dm.UnitsAndTolerances, IRhino3dm.UnitSystem, IRhino3dm.UnknownUserData, IRhino3dm.UserData, IRhino3dm.UserString, IRhino3dm.UserStringList, IRhino3dm.UUID, IRhino3dm.UUIDIndex, IRhino3dm.Viewport, IRhino3dm.WindowsBitmap, IRhino3dm.WindowsBitmapEx, IRhino3dm.Xform`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `boolean` | `eof`
    `IRhino3dm.Rhino3dmFile` | `file`
    `java.io.InputStream` | `istream`
    `java.util.ArrayList<IObject>` | `objects`
    `IServerI` | `server`

    - ### Fields inherited from class igeo.io.IRhino3dm

      `activeSpaceModelSpace, activeSpaceNoSpace, activeSpacePageSpace, colorSourceFromLayer, colorSourceFromMaterial, colorSourceFromObject, colorSourceFromParent, linetypeSourceFromLayer, linetypeSourceFromObject, linetypeSourceFromParent, materialSourceFromLayer, materialSourceFromObject, materialSourceFromParent, objectDecorationBothArrowHead, objectDecorationEndArrowHead, objectDecorationNoDecolation, objectDecorationStartArrowHead, objectModeCount, objectModeHiddenObject, objectModeIdefObject, objectModeLockedObject, objectModeNormalObject, plotColorSourceFromLayer, plotColorSourceFromMaterial, plotColorSourceFromObject, plotColorSourceFromParent, plotWeightSourceFromLayer, plotWeightSourceFromObject, plotWeightSourceFromParent, tcodeAnalysisMesh, tcodeAngularDimension, tcodeAnnotation, tcodeAnnotationLeader, tcodeAnnotationSettings, tcodeAnonymousChunk, tcodeBitmapPreview, tcodeBitmapRecord, tcodeBitmapTable, tcodeBumpMap, tcodeCommentBlock, tcodeCompressedMeshGeometry, tcodeCPlane, tcodeCRC, tcodeCurrentLayer, tcodeDictionary, tcodeDictionaryEnd, tcodeDictionaryEntry, tcodeDictionaryID, tcodeDimStyleRecord, tcodeDimStyleTable, tcodeDispAmResolution, tcodeDispCPLines, tcodeDisplay, tcodeDispMaxLength, tcodeEndOfFile, tcodeEndOfFileGoo, tcodeEndOfTable, tcodeFontRecord, tcodeFontTable, tcodeGeometry, tcodeGroupRecord, tcodeGroupTable, tcodeHatchPatternRecord, tcodeHatchPatternTable, tcodeHideTrace, tcodeHistoryRecordRecord, tcodeHistoryRecordTable, tcodeInstanceDefinitionRecord, tcodeInstanceDefinitionTable, tcodeInterface, tcodeLayer, tcodeLayerIndex, tcodeLayerLocked, tcodeLayerMaterialIndex, tcodeLayerName, tcodeLayerObselete1, tcodeLayerObselete2, tcodeLayerObselete3, tcodeLayerOn, tcodeLayerPickable, tcodeLayerRecord, tcodeLayerRef, tcodeLayerRenderable, tcodeLayerSnapable, tcodeLayerState, tcodeLayerTable, tcodeLayerThawed, tcodeLayerVisible, tcodeLegacyASM, tcodeLegacyASMStuff, tcodeLegacyBND, tcodeLegacyBNDStuff, tcodeLegacyCRV, tcodeLegacyCRVStuff, tcodeLegacyFAC, tcodeLegacyFACStuff, tcodeLegacyGeometry, tcodeLegacyPNT, tcodeLegacyPNTStuff, tcodeLegacyPRT, tcodeLegacyPRTStuff, tcodeLegacySHL, tcodeLegacySHLStuff, tcodeLegacySPL, tcodeLegacySPLStuff, tcodeLegacySRF, tcodeLegacySRFStuff, tcodeLegacyTolAngle, tcodeLegacyTolFit, tcodeLegacyTRM, tcodeLegacyTRMStuff, tcodeLightRecord, tcodeLightRecordAttributes, tcodeLightRecordAttributesUserData, tcodeLightRecordEnd, tcodeLightTable, tcodeLinearDimension, tcodeLineTypeRecord, tcodeLinetypeTable, tcodeMaterialRecord, tcodeMaterialTable, tcodeMaximizedViewport, tcodeMeshObject, tcodeName, tcodeNamedCPlane, tcodeNamedView, tcodeNearClipPlane, tcodeNotes, tcodeObjectRecord, tcodeObjectRecordAttributes, tcodeObjectRecordAttributesUserData, tcodeObjectRecordEnd, tcodeObjectRecordHistory, tcodeObjectRecordHistoryData, tcodeObjectRecordHistoryHeader, tcodeObjectRecordType, tcodeObjectTable, tcodeObsoleteLayerSetRecord, tcodeObsoleteLayerSetTable, tcodeOldFullMesh, tcodeOldMeshUV, tcodeOldMeshVertexNormals, tcodeOldRhTrimesh, tcodeOpenNurbsClass, tcodeOpenNurbsClassData, tcodeOpenNurbsClassEnd, tcodeOpenNurbsClassUserData, tcodeOpenNurbsClassUserDataHeader, tcodeOpenNurbsClassUUID, tcodeOpenNurbsObject, tcodePropertiesApplication, tcodePropertiesCompressedPreviewImage, tcodePropertiesNotes, tcodePropertiesOpenNurbsVersion, tcodePropertiesPreviewImage, tcodePropertiesRevisionHistory, tcodePropertiesTable, tcodeRadialDimension, tcodeRender, tcodeRenderMaterialID, tcodeRenderMeshParams, tcodeRGB, tcodeRGBDisplay, tcodeRhinoIOObjectBrep, tcodeRhinoIOObjectData, tcodeRhinoIOObjectEnd, tcodeRhinoIOObjectNurbsCurve, tcodeRhinoIOObjectNurbsSurface, tcodeRhPoint, tcodeRhSpotLight, tcodeSettings_Never_Use_This, tcodeSettingsAnalysisMesh, tcodeSettingsAnnotation, tcodeSettingsAttributes, tcodeSettingsCurrentColor, tcodeSettingsCurrentDimStyleIndex, tcodeSettingsCurrentFontIndex, tcodeSettingsCurrentLayerIndex, tcodeSettingsCurrentMaterialIndex, tcodeSettingsCurrentWireDensity, tcodeSettingsGridDefaults, tcodeSettingsModelURL, tcodeSettingsNamedCPlaneList, tcodeSettingsNamedViewList, tcodeSettingsPluginList, tcodeSettingsRender, tcodeSettingsRenderMesh, tcodeSettingsTable, tcodeSettingsUnitsAndTols, tcodeSettingsViewList, tcodeShort, tcodeShowGrid, tcodeShowGridAxes, tcodeShowWorldAxes, tcodeSnapSide, tcodeStartSection, tcodeStuff, tcodeSummary, tcodeTable, tcodeTableRec, tcodeTextBlock, tcodeTextureMap, tcodeTextureMappingRecord, tcodeTextureMappingTable, tcodeTolerance, tcodeTransparency, tcodeUnitAndTolerances, tcodeUser, tcodeUserRecord, tcodeUserTable, tcodeUserTableRecordHeader, tcodeUserTableUUID, tcodeView, tcodeViewAttributes, tcodeViewCPlane, tcodeViewDisplayMode, tcodeViewName, tcodeViewport, tcodeViewportDisplayMode, tcodeViewportPosition, tcodeViewportTraceInfo, tcodeViewportWallPaper, tcodeViewPosition, tcodeViewRecord, tcodeViewShowConAxes, tcodeViewShowConGrid, tcodeViewShowWorldAxes, tcodeViewTarget, tcodeViewTraceImage, tcodeViewViewport, tcodeViewViewportUserData, tcodeViewWallPaper, tcodeViewWallPaperV3, tcodeXData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IRhino3dmImporter(java.io.InputStream istr, IServerI svr)` non static methods

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `isShortChunk(int header)`
    `static void` | `main(java.lang.String[] args)`
    `void` | `read()` A method to have a main reading loop.
    `static java.util.ArrayList<IObject>` | `read(java.io.File file, IServerI server)` Reading an 3dm file and creating objects in a server.
    `static byte[]` | `read(java.io.InputStream is, int len)` static methods
    `static java.util.ArrayList<IObject>` | `read(java.io.InputStream is, IServerI server)`
    `static IRhino3dm.Arc` | `readArc(java.io.InputStream is)`
    `static java.util.ArrayList<IColor>` | `readArrayColor(byte[] buf, int count)`
    `static java.util.ArrayList<IColor>` | `readArrayColor(java.io.InputStream is)`
    `static java.util.ArrayList<java.lang.Double>` | `readArrayDouble(java.io.InputStream is)`
    `static java.util.ArrayList<java.lang.Integer>` | `readArrayInt(java.io.InputStream is)`
    `static java.util.ArrayList<IVec>` | `readArrayPoint(java.io.InputStream is)`
    `static java.util.ArrayList<IVec2>` | `readArrayPoint2(byte[] buf, int count)`
    `static java.util.ArrayList<IVec2>` | `readArrayPoint2(java.io.InputStream is)`
    `static java.util.ArrayList<IVec2>` | `readArrayPoint2f(byte[] buf, int count)`
    `static java.util.ArrayList<IVec2>` | `readArrayPoint2f(java.io.InputStream is)`
    `static java.util.ArrayList<IVec>` | `readArrayPoint3f(byte[] buf, int count)`
    `static java.util.ArrayList<IVec>` | `readArrayPoint3f(java.io.InputStream is)`
    `static java.util.ArrayList<IRhino3dm.SurfaceCurvature>` | `readArraySurfaceCurvature(byte[] buf, int count)`
    `static java.util.ArrayList<IRhino3dm.SurfaceCurvature>` | `readArraySurfaceCurvature(java.io.InputStream is)`
    `static java.util.ArrayList<IRhino3dm.UUIDIndex>` | `readArrayUUIDIndex(byte[] buf, int count)`
    `static java.util.ArrayList<IRhino3dm.UUIDIndex>` | `readArrayUUIDIndex(java.io.InputStream is)`
    `IRhino3dm.Bitmap` | `readBitmap(IRhino3dm.Chunk chunk)`
    `void` | `readBitmapTable(IRhino3dm.Chunk chunk)`
    `static boolean` | `readBool(java.io.InputStream is)`
    `static IRhino3dm.BoundingBox` | `readBoundingBox(java.io.InputStream is)`
    `static byte` | `readByte(java.io.InputStream is)`
    `static byte[]` | `readBytes(java.io.InputStream is, int len)`
    `static char` | `readChar(java.io.InputStream is)`
    `static IRhino3dm.Chunk` | `readChunk(java.io.InputStream is)`
    `static IRhino3dm.Chunk[]` | `readChunkTable(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.Chunk[]` | `readChunkTable(IRhino3dm.Chunk chunk, int endTCode)`
    `static int[]` | `readChunkVersion(byte b)`
    `static int[]` | `readChunkVersion(java.io.InputStream is)`
    `static IRhino3dm.Circle` | `readCircle(java.io.InputStream is)`
    `static IColor` | `readColor(java.io.InputStream is)`
    `static IColor` | `readColor(int i)`
    `static byte[]` | `readCompressedBuffer(java.io.InputStream is, int len)`
    `static int` | `readCompressedBufferSize(java.io.InputStream is)`
    `IRhino3dm.DimStyle` | `readDimStyle(IRhino3dm.Chunk chunk)`
    `void` | `readDimStyleTable(IRhino3dm.Chunk chunk)`
    `static double` | `readDouble(byte[] b)`
    `static double` | `readDouble(java.io.InputStream is)`
    `void` | `readEndMark(IRhino3dm.Chunk chunk)`
    `void` | `readFileHeader()`
    `static float` | `readFloat(byte[] b)`
    `static float` | `readFloat(java.io.InputStream is)`
    `IRhino3dm.Font` | `readFont(IRhino3dm.Chunk chunk)`
    `void` | `readFontTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.Group` | `readGroup(IRhino3dm.Chunk chunk)`
    `void` | `readGroupTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.HatchPattern` | `readHatchPattern(IRhino3dm.Chunk c)`
    `void` | `readHatchPatternTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.HistoryRecord` | `readHistoryRecord(IRhino3dm.Chunk chunk)`
    `void` | `readHistoryRecordTable(IRhino3dm.Chunk chunk)`
    `static byte[]` | `readInflate(java.io.InputStream is, int len)`
    `IRhino3dm.InstanceDefinition` | `readInstanceDefinition(IRhino3dm.Chunk chunk)`
    `void` | `readInstanceDefinitionTable(IRhino3dm.Chunk chunk)`
    `static int` | `readInt(java.io.InputStream is)`
    `static short` | `readInt16(byte[] b)`
    `static short` | `readInt16(java.io.InputStream is)`
    `static int` | `readInt32(byte[] b)`
    `static int` | `readInt32(java.io.InputStream is)`
    `static long` | `readInt64(byte[] b)`
    `static long` | `readInt64(java.io.InputStream is)`
    `static IRhino3dm.Interval` | `readInterval(java.io.InputStream is)`
    `IRhino3dm.Layer` | `readLayer(IRhino3dm.Chunk chunk)`
    `void` | `readLayerTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.Light` | `readLight(IRhino3dm.Chunk c)`
    `void` | `readLightTable(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.Line` | `readLine(java.io.InputStream is)`
    `IRhino3dm.Linetype` | `readLinetype(IRhino3dm.Chunk chunk)`
    `void` | `readLinetypeTable(IRhino3dm.Chunk chunk)`
    `static long` | `readLong(java.io.InputStream is)`
    `IRhino3dm.Material` | `readMaterial(IRhino3dm.Chunk chunk)`
    `void` | `readMaterialTable(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.Chunk` | `readNestedChunk(IRhino3dm.Chunk chunk)`
    `IRhino3dm.RhinoObject` | `readObject(java.io.InputStream is)`
    `IRhino3dm.RhinoObject` | `readObject(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.RhinoObject` | `readObject(IRhino3dm.Rhino3dmFile context, java.io.InputStream is)`
    `static IRhino3dm.RhinoObject` | `readObject(IRhino3dm.Rhino3dmFile context, IRhino3dm.Chunk chunk)`
    `void` | `readObjectTable(IRhino3dm.Chunk chunk)`
    `void` | `readObjectUserData(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.Plane` | `readPlane(java.io.InputStream is)`
    `static IVec2` | `readPoint2(java.io.InputStream is)`
    `static IVec2` | `readPoint2f(java.io.InputStream is)`
    `static IVec` | `readPoint3(java.io.InputStream is)`
    `static IVec` | `readPoint3f(java.io.InputStream is)`
    `static IVec` | `readPoint4(java.io.InputStream is)`
    `static IRhino3dm.PointArray` | `readPointArray(java.io.InputStream is)`
    `static IRhino3dm.Polyline` | `readPolyline(java.io.InputStream is)`
    `void` | `readPropertiesTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.RhinoObject` | `readRhinoObject(IRhino3dm.Chunk chunk)`
    `void` | `readSettingsTable(IRhino3dm.Chunk chunk)`
    `static short` | `readShort(java.io.InputStream is)`
    `static int` | `readSize(java.io.InputStream is)`
    `void` | `readStartSection(IRhino3dm.Chunk chunk)`
    `static java.lang.String` | `readString(java.io.InputStream is)`
    `static IRhino3dm.SurfaceCurvature` | `readSurfaceCurvature(java.io.InputStream is)`
    `IRhino3dm.TextureMapping` | `readTextureMapping(IRhino3dm.Chunk chunk)`
    `void` | `readTextureMappingTable(IRhino3dm.Chunk chunk)`
    `IRhino3dm.UserData` | `readUserData(IRhino3dm.Chunk chunk)`
    `void` | `readUserDataTable(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.UUID` | `readUUID(java.io.InputStream is)`
    `static IRhino3dm.UUID` | `readUUID(IRhino3dm.Chunk chunk)`
    `static IRhino3dm.Xform` | `readXform(java.io.InputStream is)`
    `static void` | `skip(java.io.InputStream is, int len)`

    - ### Methods inherited from class igeo.io.IRhino3dm

      `annotationType, annotationType, asciiOrHex, btoi, endian, endian, hex, hex, hex, hex, hex, hex, hexCharToByte, hexCharToByte, hexStringToByte, itob, ltob, printAsciiOrHex, printHex, stob, textDisplayMode, textDisplayMode`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### istream

          public java.io.InputStream istream

    - #### eof

          public boolean eof

    - #### file

          public IRhino3dm.Rhino3dmFile file

    - #### server

          public IServerI server

    - #### objects

          public java.util.ArrayList<IObject> objects

  - ### Constructor Detail

    - #### IRhino3dmImporter

          public IRhino3dmImporter(java.io.InputStream istr,
                                   IServerI svr)

      non static methods

  - ### Method Detail

    - #### readFileHeader

          public void readFileHeader()
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### read

          public static byte[] read(java.io.InputStream is,
                                    int len)
                             throws java.io.IOException

      static methods
      Throws:
        `java.io.IOException`

    - #### skip

          public static void skip(java.io.InputStream is,
                                  int len)
                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readChar

          public static char readChar(java.io.InputStream is)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readByte

          public static byte readByte(java.io.InputStream is)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readBytes

          public static byte[] readBytes(java.io.InputStream is,
                                         int len)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readBool

          public static boolean readBool(java.io.InputStream is)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readShort

          public static short readShort(java.io.InputStream is)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt16

          public static short readInt16(java.io.InputStream is)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt16

          public static short readInt16(byte[] b)

    - #### readInt

          public static int readInt(java.io.InputStream is)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt32

          public static int readInt32(java.io.InputStream is)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt32

          public static int readInt32(byte[] b)

    - #### readLong

          public static long readLong(java.io.InputStream is)
                               throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt64

          public static long readInt64(java.io.InputStream is)
                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInt64

          public static long readInt64(byte[] b)

    - #### readFloat

          public static float readFloat(java.io.InputStream is)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readFloat

          public static float readFloat(byte[] b)

    - #### readDouble

          public static double readDouble(java.io.InputStream is)
                                   throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readDouble

          public static double readDouble(byte[] b)

    - #### readColor

          public static IColor readColor(java.io.InputStream is)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readColor

          public static IColor readColor(int i)

    - #### readString

          public static java.lang.String readString(java.io.InputStream is)
                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readUUID

          public static IRhino3dm.UUID readUUID(IRhino3dm.Chunk chunk)
                                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readUUID

          public static IRhino3dm.UUID readUUID(java.io.InputStream is)
                                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPoint2

          public static IVec2 readPoint2(java.io.InputStream is)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPoint2f

          public static IVec2 readPoint2f(java.io.InputStream is)
                                   throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPoint3

          public static IVec readPoint3(java.io.InputStream is)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPoint3f

          public static IVec readPoint3f(java.io.InputStream is)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPoint4

          public static IVec readPoint4(java.io.InputStream is)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readLine

          public static IRhino3dm.Line readLine(java.io.InputStream is)
                                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPlane

          public static IRhino3dm.Plane readPlane(java.io.InputStream is)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readSurfaceCurvature

          public static IRhino3dm.SurfaceCurvature readSurfaceCurvature(java.io.InputStream is)
                                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayInt

          public static java.util.ArrayList<java.lang.Integer> readArrayInt(java.io.InputStream is)
                                                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayDouble

          public static java.util.ArrayList<java.lang.Double> readArrayDouble(java.io.InputStream is)
                                                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint

          public static java.util.ArrayList<IVec> readArrayPoint(java.io.InputStream is)
                                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint2

          public static java.util.ArrayList<IVec2> readArrayPoint2(java.io.InputStream is)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint2

          public static java.util.ArrayList<IVec2> readArrayPoint2(byte[] buf,
                                                                   int count)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayColor

          public static java.util.ArrayList<IColor> readArrayColor(java.io.InputStream is)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayColor

          public static java.util.ArrayList<IColor> readArrayColor(byte[] buf,
                                                                   int count)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint2f

          public static java.util.ArrayList<IVec2> readArrayPoint2f(java.io.InputStream is)
                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint2f

          public static java.util.ArrayList<IVec2> readArrayPoint2f(byte[] buf,
                                                                    int count)
                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint3f

          public static java.util.ArrayList<IVec> readArrayPoint3f(java.io.InputStream is)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayPoint3f

          public static java.util.ArrayList<IVec> readArrayPoint3f(byte[] buf,
                                                                   int count)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArraySurfaceCurvature

          public static java.util.ArrayList<IRhino3dm.SurfaceCurvature> readArraySurfaceCurvature(java.io.InputStream is)
                                                                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArraySurfaceCurvature

          public static java.util.ArrayList<IRhino3dm.SurfaceCurvature> readArraySurfaceCurvature(byte[] buf,
                                                                                                  int count)
                                                                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayUUIDIndex

          public static java.util.ArrayList<IRhino3dm.UUIDIndex> readArrayUUIDIndex(java.io.InputStream is)
                                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArrayUUIDIndex

          public static java.util.ArrayList<IRhino3dm.UUIDIndex> readArrayUUIDIndex(byte[] buf,
                                                                                    int count)
                                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPointArray

          public static IRhino3dm.PointArray readPointArray(java.io.InputStream is)
                                                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readPolyline

          public static IRhino3dm.Polyline readPolyline(java.io.InputStream is)
                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readCircle

          public static IRhino3dm.Circle readCircle(java.io.InputStream is)
                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readArc

          public static IRhino3dm.Arc readArc(java.io.InputStream is)
                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInterval

          public static IRhino3dm.Interval readInterval(java.io.InputStream is)
                                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readXform

          public static IRhino3dm.Xform readXform(java.io.InputStream is)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readBoundingBox

          public static IRhino3dm.BoundingBox readBoundingBox(java.io.InputStream is)
                                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readChunkVersion

          public static int[] readChunkVersion(java.io.InputStream is)
                                        throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readChunkVersion

          public static int[] readChunkVersion(byte b)

    - #### isShortChunk

          public static boolean isShortChunk(int header)

    - #### readChunk

          public static IRhino3dm.Chunk readChunk(java.io.InputStream is)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readChunkTable

          public static IRhino3dm.Chunk[] readChunkTable(IRhino3dm.Chunk chunk)

    - #### readChunkTable

          public static IRhino3dm.Chunk[] readChunkTable(IRhino3dm.Chunk chunk,
                                                         int endTCode)

    - #### readNestedChunk

          public static IRhino3dm.Chunk readNestedChunk(IRhino3dm.Chunk chunk)

    - #### readObject

          public IRhino3dm.RhinoObject readObject(java.io.InputStream is)
                                           throws java.io.IOException

      Returns:
        returns class data byte array
      Throws:
        `java.io.IOException`

    - #### readObject

          public IRhino3dm.RhinoObject readObject(IRhino3dm.Chunk chunk)

      Returns:
        returns class data byte array

    - #### readObject

          public static IRhino3dm.RhinoObject readObject(IRhino3dm.Rhino3dmFile context,
                                                         java.io.InputStream is)
                                                  throws java.io.IOException

      Returns:
        returns class data byte array
      Throws:
        `java.io.IOException`

    - #### readObject

          public static IRhino3dm.RhinoObject readObject(IRhino3dm.Rhino3dmFile context,
                                                         IRhino3dm.Chunk chunk)

    - #### readCompressedBufferSize

          public static int readCompressedBufferSize(java.io.InputStream is)
                                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readSize

          public static int readSize(java.io.InputStream is)
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readCompressedBuffer

          public static byte[] readCompressedBuffer(java.io.InputStream is,
                                                    int len)
                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readInflate

          public static byte[] readInflate(java.io.InputStream is,
                                           int len)
                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### read

          public static java.util.ArrayList<IObject> read(java.io.File file,
                                                          IServerI server)

      Reading an 3dm file and creating objects in a server. The main entry of the importer class.
      Parameters:
        `file` - An importing file object.
        `server` - A server interface to put imported objects in.
      Returns:
        True if reading is successful. Otherwise false.

    - #### read

          public static java.util.ArrayList<IObject> read(java.io.InputStream is,
                                                          IServerI server)

    - #### read

          public void read()

      A method to have a main reading loop.

    - #### readStartSection

          public void readStartSection(IRhino3dm.Chunk chunk)

    - #### readPropertiesTable

          public void readPropertiesTable(IRhino3dm.Chunk chunk)

    - #### readSettingsTable

          public void readSettingsTable(IRhino3dm.Chunk chunk)
                                 throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readBitmapTable

          public void readBitmapTable(IRhino3dm.Chunk chunk)

    - #### readBitmap

          public IRhino3dm.Bitmap readBitmap(IRhino3dm.Chunk chunk)

    - #### readTextureMappingTable

          public void readTextureMappingTable(IRhino3dm.Chunk chunk)

    - #### readTextureMapping

          public IRhino3dm.TextureMapping readTextureMapping(IRhino3dm.Chunk chunk)

    - #### readMaterialTable

          public void readMaterialTable(IRhino3dm.Chunk chunk)

    - #### readMaterial

          public IRhino3dm.Material readMaterial(IRhino3dm.Chunk chunk)

    - #### readLinetypeTable

          public void readLinetypeTable(IRhino3dm.Chunk chunk)

    - #### readLinetype

          public IRhino3dm.Linetype readLinetype(IRhino3dm.Chunk chunk)

    - #### readLayerTable

          public void readLayerTable(IRhino3dm.Chunk chunk)

    - #### readLayer

          public IRhino3dm.Layer readLayer(IRhino3dm.Chunk chunk)

    - #### readGroupTable

          public void readGroupTable(IRhino3dm.Chunk chunk)

    - #### readGroup

          public IRhino3dm.Group readGroup(IRhino3dm.Chunk chunk)

    - #### readFontTable

          public void readFontTable(IRhino3dm.Chunk chunk)

    - #### readFont

          public IRhino3dm.Font readFont(IRhino3dm.Chunk chunk)

    - #### readDimStyleTable

          public void readDimStyleTable(IRhino3dm.Chunk chunk)

    - #### readDimStyle

          public IRhino3dm.DimStyle readDimStyle(IRhino3dm.Chunk chunk)

    - #### readLightTable

          public void readLightTable(IRhino3dm.Chunk chunk)

    - #### readLight

          public IRhino3dm.Light readLight(IRhino3dm.Chunk c)

    - #### readHatchPatternTable

          public void readHatchPatternTable(IRhino3dm.Chunk chunk)

    - #### readHatchPattern

          public IRhino3dm.HatchPattern readHatchPattern(IRhino3dm.Chunk c)

    - #### readInstanceDefinitionTable

          public void readInstanceDefinitionTable(IRhino3dm.Chunk chunk)

    - #### readInstanceDefinition

          public IRhino3dm.InstanceDefinition readInstanceDefinition(IRhino3dm.Chunk chunk)

    - #### readObjectTable

          public void readObjectTable(IRhino3dm.Chunk chunk)

    - #### readRhinoObject

          public IRhino3dm.RhinoObject readRhinoObject(IRhino3dm.Chunk chunk)

    - #### readObjectUserData

          public void readObjectUserData(IRhino3dm.Chunk chunk)

    - #### readHistoryRecordTable

          public void readHistoryRecordTable(IRhino3dm.Chunk chunk)

    - #### readHistoryRecord

          public IRhino3dm.HistoryRecord readHistoryRecord(IRhino3dm.Chunk chunk)

    - #### readUserDataTable

          public void readUserDataTable(IRhino3dm.Chunk chunk)

    - #### readUserData

          public IRhino3dm.UserData readUserData(IRhino3dm.Chunk chunk)

    - #### readEndMark

          public void readEndMark(IRhino3dm.Chunk chunk)

    - #### main

          public static void main(java.lang.String[] args)